Attribute VB_Name = "ModStringPerm"
Option Explicit

'hier die Static-Prozeduren von StringPerm
Public Function FactorialCompute(n As Long) As Variant
    Dim answer As Variant: answer = CDec(1)
    Dim i As Long
    For i = 1 To n - 1
        answer = Checked(answer * CDec(i))
    Next
    FactorialCompute = answer
End Function

Public Function FactorialLookup(n As Long) As Variant
    If (n < 0 Or n > 20) Then _
        MsgBox "Input argument must be between 0 and 20"
    
    Static answers() As Variant
    answers = Array(1, 1, 2, 6, 24, 120, 720, 5040, 40320, _
                   362880, 3628800, 39916800, 479001600, _
                   6227020800#, 87178291200#, 1307674368000#, _
                   20922789888000#, 355687428096000#, 6.402373705728E+15, _
                   1.21645100408832E+17, 2.43290200817664E+18)

    FactorialLookup = answers(n)
End Function

Public Function FactorialRecursive(n As Long) As Variant

    If (n = 0 Or n = 1) Then
        FactorialRecursive = 1: Exit Function
    Else
        FactorialRecursive = n * FactorialRecursive(n - 1)
    End If

End Function

Public Property Get IsValid(e() As String) As Boolean
    Dim i As Long
    
    If UBound(e) = 0 Then
        IsValid = False: Exit Function
    End If
    
    If UBound(e) < 2 Then
        IsValid = False: Exit Function
    End If
    
    For i = 0 To UBound(e) - 1
        If StrComp(e(i), e(i + 1)) >= 0 Then ' >= means no dups allowed
            IsValid = False: Exit Function
        End If
    Next
    
    IsValid = True
End Property
