VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   7590
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   7335
   LinkTopic       =   "Form1"
   ScaleHeight     =   7590
   ScaleWidth      =   7335
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton BtnStart 
      Caption         =   "Start"
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   1455
   End
   Begin VB.TextBox Text1 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   6975
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Beides
      TabIndex        =   0
      Top             =   480
      Width           =   7095
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private mConsoleStrBuffer As String
Private mCharLen As Long

Private Sub BtnStart_Click()
    Dim atoms() As String
    Dim Order As Long
    Dim j As Long
    Dim p As StringPerm
    Dim i As Long
    
    Call Console_WriteLine(vbCrLf & "Begin string permutations demo" & vbCrLf)
    atoms = New_StringArr("Ant", "Bat", "Cow", "Dog", "Elk", "Fox")
    Call Console_WriteLine("The initial strings (atoms) are: ")
    
    For j = 0 To UBound(atoms)
        Call Console_WriteLine(atoms(j) & " ")
    Next
    
    Order = UBound(atoms) + 1
    Call Console_WriteLine(vbCrLf & "The order is " & CStr(Order))
    Call Console_WriteLine("There will be " & CStr(Order) & "! = " & _
                           ModStringPerm.FactorialLookup(Order) & _
                           " pemutation elements")
      
    If Not ModStringPerm.IsValid(atoms) Then _
        MsgBox "Invalid initial array"
    
    Set p = New_StringPerm(atoms)
  
    
    Call Console_WriteLine("In lexicographical order, all permutations are: " & vbCrLf)
    
    Do While Not p Is Nothing
        Call Console_WriteLine("[" & CStr(i) & IIf(i < 10, " ", "") & "] " & p.ToString)
        Set p = p.Successor
        i = i + 1
    Loop
    
    Call Console_WriteLine(vbCrLf & "Just element [142] computed directly is:")
    Set p = New_StringPerm(atoms, 142)
    
    Call Console_WriteLine("     " & p.ToString())
  
    Call Console_WriteLine(vbCrLf & "End demo")
End Sub

Private Sub Console_WriteLine(ByVal aText As String)
  Text1.Visible = False
  aText = aText & vbCrLf
  If Len(mConsoleStrBuffer) = 0 Then
      mConsoleStrBuffer = String$(30000, vbNullChar)
      Text1.Text = mConsoleStrBuffer
  End If
  
  If mCharLen < Len(mConsoleStrBuffer) Then
    Mid$(mConsoleStrBuffer, mCharLen + 1) = aText
    
    mCharLen = mCharLen + Len(aText)
  End If
  
  Text1.Text = mConsoleStrBuffer
  Text1.Visible = True
End Sub
